//
//  main.cpp
//  Lab#4-3
//
//  Created by Tammy on 3/24/15.
//  Copyright (c) 2015 Tammy. All rights reserved.
//
// declare a knapsack function with five parameters
int knapsackValue (const int v[], const int w[], int B, int n, const bool sol[]);

#include<iostream>
using namespace std;
int main() {
    //get the number of items and the knapsack capacity
    int n=0, B=0;
    cin>>n>>B;
    //get the weight of items
    int* weight=new int[n];
    for(int i=0; i<n; i++) {
        int tempWeight=0;
        cin>>tempWeight;
        weight[i]=tempWeight;
    }
    //get the value of items
    int* value=new int[n];
    for(int i=0; i<n; i++) {
        int tempValue=0;
        cin>>tempValue;
        value[i]=tempValue;
    }
    // get the number of candidates
    int k=0;
    cin>>k;
    int* canValue = new int[k];
    int* canWeight = new int[k];
    // initialize the best solution
    int bestIndex=0;
    int bestValue=-1;
    int bestWeight=0;
    for(int i=0; i<k; i++){
        // get the index of the current candidate
        int m=0;
        cin>>m;
        // initialize the canValue and canWeight array
        canValue[i] = 0;
        canWeight[i] = 0;
        // get what items the current candidate choose and the total weight
        bool* choose = new bool[n];
        for(int j=0; j<n; j++){
            choose[j] = false;
            cin >> choose[j];
            if(choose[j]){
                canWeight[i]+=weight[j];
            }
        }

        // invoke knapsack function and use returnValue to store the value returned
        canValue[i] = knapsackValue (value, weight, B, n, choose);
    }
    // modify the best value if the return value is greater
    for(int f=0; f<k; f++){
        if(canValue[f]>bestValue){
            bestValue = canValue[f];
            bestIndex = f+1;
            bestWeight = canWeight[f];
        }
    }
    // print the best value
    cout <<bestIndex <<" "<<bestWeight<<" "<<bestValue<<endl;
    return 0;
    
}
// knapsack function
int knapsackValue (const int v[], const int w[], int B, int n, const bool sol[]){
    //compute the total weight and the total value of the current candidate
    int tempValue = 0;
    int tempWeight = 0;
    for(int j=0; j<n; j++){
        if(sol[j]){
            tempValue+=v[j];
            tempWeight+=w[j];
        }
    }
    //if total weight is valid, return the value; if it's invalid, return -1;
    if(tempWeight<=B){
        return tempValue;
    }
    else{
        return -1;
    }
}
